// CTokenDemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "CTokenDemo.h"
#include "CTokenDemoDlg.h"
#include "Token.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCTokenDemoDlg dialog

CCTokenDemoDlg::CCTokenDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCTokenDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCTokenDemoDlg)
	m_strToTokenize = _T("");
	m_TokenOn = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CCTokenDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCTokenDemoDlg)
	DDX_Control(pDX, IDC_TOKENIZE, m_btnTokenize);
	DDX_Control(pDX, IDC_CLEAR, m_btnClear);
	DDX_Control(pDX, IDC_LIST_TOKENS, m_lstTokens);
	DDX_Text(pDX, IDC_EDIT_TOKENSTRING, m_strToTokenize);
	DDV_MaxChars(pDX, m_strToTokenize, 30);
	DDX_Text(pDX, IDC_EDIT_TOKENON, m_TokenOn);
	DDV_MaxChars(pDX, m_TokenOn, 10);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCTokenDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CCTokenDemoDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CLEAR, OnClear)
	ON_EN_KILLFOCUS(IDC_EDIT_TOKENON, OnKillfocusEditTokenon)
	ON_EN_KILLFOCUS(IDC_EDIT_TOKENSTRING, OnKillfocusEditTokenstring)
	ON_BN_CLICKED(IDC_TOKENIZE, OnTokenize)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCTokenDemoDlg message handlers

BOOL CCTokenDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CCTokenDemoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CCTokenDemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CCTokenDemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CCTokenDemoDlg::OnClear() 
{
	m_lstTokens.ResetContent();
	m_strToTokenize = "";
	m_TokenOn = "";
	UpdateData(FALSE);
	m_btnClear.EnableWindow(FALSE);
	m_btnTokenize.EnableWindow(FALSE);
	
}

void CCTokenDemoDlg::OnKillfocusEditTokenon() 
{
	UpdateData(TRUE);
	if (m_TokenOn.IsEmpty())
	{
		m_TokenOn = " ";
	}
	
}

void CCTokenDemoDlg::OnKillfocusEditTokenstring() 
{
	UpdateData(TRUE);
	if (!m_strToTokenize.IsEmpty())
		m_btnTokenize.EnableWindow(TRUE);
}

void CCTokenDemoDlg::OnTokenize() 
{
	UpdateData(TRUE);
	int nTokens = 0;
	CString sToken;

	CToken tok(m_strToTokenize);
	tok.SetToken(m_TokenOn);

	while(tok.MoreTokens())
	{
		nTokens++;
		sToken.Format("%d. %s",nTokens,tok.GetNextToken());
		m_lstTokens.InsertString(m_lstTokens.GetCount(),sToken);
	}

	m_btnClear.EnableWindow(TRUE);	
}
